Package twisted :: Package web :: Module resource :: Class Resource |
[frames | no frames]

## Class Resource

Known Subclasses:
  `_HostResource`, `ASISProcessor`, `BlankPage`, `CGIDirectory`, `CGIScript`, `Controller`, `Data`, `DeferredResource`, `DOMController`, `DOMTemplate`, `ErrorPage`, `File`, `FormProcessor`, `Gadget`, `ModelLoader`, `NameVirtualHost`, `Page`, `ParentRedirect`, `PerspectiveWrapper`, `PythonScript`, `Redirect`, `Redirect`, `Resource`, `ResourceGuard`, `ResourceScriptDirectory`, `ResourceScriptWrapper`, `ResourceSubscription`, `ReverseProxyResource`, `RewriterResource`, `SessionWrapper`, `SOAPPublisher`, `Tapestry`, `UsernamePasswordWrapper`, `VHostMonsterResource`, `WidgetResource`, `XMLRPC`

I define a web-accessible resource.

I serve 2 main purposes; one is to provide a standard representation for what HTTP specification calls an 'entity', and the other is to provide an abstract directory structure for URL retrieval.

Method Summary
| ``__init__`(self)` Initialize.
| `delEntity(self, name)`
| ``getChild`(self, path, request)` Retrieve a 'child' resource from me.
| `getChildForRequest(self, request)`
| ``getChildWithDefault`(self, path, request)` Retrieve a static or dynamically generated child resource from me.
| `getDynamicEntity(self, name, request)`
| `getStaticEntity(self, name)`
| `listDynamicEntities(self, request)`
| `listDynamicNames(self)`
| `listEntities(self)`
| `listNames(self)`
| `listStaticEntities(self)`
| `listStaticNames(self)`
| ``putChild`(self, path, child)` Register a static child.
| `reallyPutEntity(self, name, entity)`
| ``render`(self, request)` Render a given resource.

Class Variable Summary
`tuple` | `__implements__` = `(<class twisted.web.resource.IResource ...`
`class` | `entityType` = `twisted.web.resource.IResource`
`int` | `isLeaf` = 0
`NoneType` | `server` = None

Method Details

### __init__(self) (Constructor) Initialize.

### getChild(self, path, request) Retrieve a 'child' resource from me. Implement this to create dynamic resource generation -- resources which are always available may be registered with self.putChild(). This will not be called if the class-level variable 'isLeaf' is set in your subclass; instead, the 'postpath' attribute of the request will be left as a list of the remaining path elements. For example, the URL /foo/bar/baz will normally be:
     | site.resource.getChild('foo').getChild('bar').getChild('baz').
However, if the resource returned by 'bar' has isLeaf set to true, then the getChild call will never be made on it. Parameters: `path` - a string, describing the child `request` - a twisted.web.server.Request specifying meta-information about the request that is being made for this child.

### getChildWithDefault(self, path, request) Retrieve a static or dynamically generated child resource from me. First checks if a resource was added manually by putChild, and then call getChild to check for dynamic resources. Only override if you want to affect behaviour of all child lookups, rather than just dynamic ones. This will check to see if I have a pre-registered child resource of the given name, and call getChild if I do not.

### putChild(self, path, child) Register a static child.

### render(self, request) Render a given resource. This must be implemented in all subclasses of Resource. The return value of this method will be the rendered page, unless the return value is twisted.web.server.NOT_DONE_YET, in which case it is this class's responsibility to write the results to request.write(data), then call request.finish().

Class Variable Details

    ### __implements__ Type: `tuple` Value:
        (<class twisted.web.resource.IResource at 0x8436174>,)

    ### isLeaf Type: `int` Value:
        0

    ### server Type: `NoneType` Value:
        None

Generated by Epydoc 2.0 on Sat Oct 25 00:55:12 2003 | http://epydoc.sf.net